/****************************************************************************/
/*                Primes Benchmark for Canon PowerShot A70	      	    */
/****************************************************************************/
/* Created: 5.12.2004 [BORLAND C 3.1]         		                    */
/* Last modified: 6.5.2005 [BORLAND C 3.1]	                            */
/* Copyright (C) 2004-2005 by RayeR, Lexeich, Gambistics, Nick T Tate       */
/* Contact: http://www.volny.cz/rayer                                       */
/* Compiler: Borland C++ 3.1, disable Word Alignment, set 80186 code gen.   */
/****************************************************************************/
#include "psiolib.c"                   // PowerShot I/O library 2.0+

DWord t1,t2,cnt=0;
Word i,j;
Byte is_prime;

int main(void)
{
  ps_init();
  ps_gotoxy(0,0);
  ps_cls(15,0);
  ps_printf(1,14,0,"RayeR's Primes Benchmark (C)2004\n");
  t1=ps_get_timer();
  for (i=1; i<1000; i++)
    {
    is_prime=1;
    for (j=2; j<(i-1); j++)            // 20 ASM instructions
      {
      if ((i%j)==0)
	is_prime=0;
      cnt++;
      }
    if (is_prime==1)
      ps_printf(0,14,0,"%d ",i);
    if (ps_where_x>(PS_SCREEN_XRES-4*PS_FONT_W))
      {
      ps_where_x=0;
      ps_where_y+=2*PS_FONT_H;
      ps_refresh_lcd();
      }
    if (ps_where_y>(PS_SCREEN_YRES-2*PS_FONT_H))
      {
      ps_gotoxy(0,0);
      ps_cls(15,1);
      }
    }
  t2=ps_get_timer()-t1;
  ps_printf(0,0,0,"\n");
  ps_printf(1,14,0,"run time: %ld ms\n",t2);
  ps_printf(1,14,0,"run loops: %ld\n",cnt);
  ps_printf(1,14,0,"performance: %ld loops/s\n",(1000*cnt)/t2);
  ps_printf(1,14,0,"(1 loop =~ 20 ASM instructions)\n");
  ps_printf(1,14,0,"(A70: 66700 loops/s)\n");
  ps_printf(1,14,0,"press MENU button to exit");
  ps_wait_for_key(PS_KEY_MENU|PS_KEY_SHOOT_MODE|PS_KEY_POWER);
  return(0);
}
